<?php
function interior_services_get_all_google_fonts() {
    $interior_services_webfonts_json = get_template_directory() . '/theme-library/google-webfonts.json';
    if ( ! file_exists( $interior_services_webfonts_json ) ) {
        return array();
    }

    $interior_services_fonts_json_data = file_get_contents( $interior_services_webfonts_json );
    if ( false === $interior_services_fonts_json_data ) {
        return array();
    }

    $interior_services_all_fonts = json_decode( $interior_services_fonts_json_data, true );
    if ( json_last_error() !== JSON_ERROR_NONE ) {
        return array();
    }

    $interior_services_google_fonts = array();
    foreach ( $interior_services_all_fonts as $interior_services_font ) {
        $interior_services_google_fonts[ $interior_services_font['family'] ] = array(
            'family'   => $interior_services_font['family'],
            'variants' => $interior_services_font['variants'],
        );
    }
    return $interior_services_google_fonts;
}

function interior_services_get_all_google_font_families() {
    $interior_services_google_fonts  = interior_services_get_all_google_fonts();
    $interior_services_font_families = array();
    foreach ( $interior_services_google_fonts as $interior_services_font ) {
        $interior_services_font_families[ $interior_services_font['family'] ] = $interior_services_font['family'];
    }
    return $interior_services_font_families;
}

function interior_services_get_fonts_url() {
    $interior_services_fonts_url = '';
    $interior_services_fonts     = array();

    $interior_services_all_fonts = interior_services_get_all_google_fonts();

    if ( ! empty( get_theme_mod( 'interior_services_site_title_font', 'Montserrat' ) ) ) {
        $interior_services_fonts[] = get_theme_mod( 'interior_services_site_title_font', 'Montserrat' );
    }

    if ( ! empty( get_theme_mod( 'interior_services_site_description_font', 'Montserrat' ) ) ) {
        $interior_services_fonts[] = get_theme_mod( 'interior_services_site_description_font', 'Montserrat' );
    }

    if ( ! empty( get_theme_mod( 'interior_services_header_font', 'Montserrat' ) ) ) {
        $interior_services_fonts[] = get_theme_mod( 'interior_services_header_font', 'Montserrat' );
    }

    if ( ! empty( get_theme_mod( 'interior_services_content_font', 'Montserrat' ) ) ) {
        $interior_services_fonts[] = get_theme_mod( 'interior_services_content_font', 'Montserrat' );
    }

    $interior_services_fonts = array_unique( $interior_services_fonts );

    foreach ( $interior_services_fonts as $interior_services_font ) {
        $interior_services_variants      = $interior_services_all_fonts[ $interior_services_font ]['variants'];
        $interior_services_font_family[] = $interior_services_font . ':' . implode( ',', $interior_services_variants );
    }

    $interior_services_query_args = array(
        'family' => urlencode( implode( '|', $interior_services_font_family ) ),
    );

    if ( ! empty( $interior_services_font_family ) ) {
        $interior_services_fonts_url = add_query_arg( $interior_services_query_args, 'https://fonts.googleapis.com/css' );
    }

    return $interior_services_fonts_url;
}